<?php
#
# $Id: index.php3,v 1.20 2002/02/06 12:02:03 dom Exp $
# Copyright (C) 2001, 2002 Dominic Hargreaves <dom@earth.li>
# Main web interface page for the mediadbs
# 
# This file is part of mediadbs.
#
# mediadbs is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# mediadbs is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with mediadbs; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

include("config.inc");
include("util.inc");
include("header.inc");

$max_num = 500;

if (!$order) {
   $order = "title";
}

if ($genre == "-1") {
   $genrestring = "1";
} else {
   $genrestring = "genre=$genre";
}

if ($albumsearch == "yes") {
   if ($searchon) {
      $result = mysql_query("SELECT * FROM albums WHERE
                          ($searchon LIKE '%$value%' OR
                          $searchon LIKE REPLACE('%$value%', ' ', '_'))
                           AND $genrestring ORDER BY artist, title");
      if ($result and $myrow = mysql_fetch_array($result)) {
         $num = mysql_numrows($result);
         print "Number of hits: $num<p>\n";
         if ($num < $max_num) {
            echo "<table border=\"0\" cellspacing=\"7\">\n<tr>
            <th>Title</th>       <th>Artist</th>
            </tr>\n";
            do {
               printf("<tr><td><a href=\"albumdetails.php3?albumid=%s\">",
                        $myrow["albumid"]);
               printf("%s</a></td>", $myrow["title"]);
               printf("<td>%s</td>
                       </tr>\n",
                       $myrow["artist"]);
            } while ($myrow = mysql_fetch_array($result));

            echo "</table>\n<p>";
         } else {
            print "Too many matches. Please narrow your search.\n";
         }
      } else {
         echo "No matches.\n";
      }
   } else {
      echo "wibble";
   }
} else { # We are doing an ordinary search
   if ($searchon) {
      if ($searchon == "filename") {
         $result = mysql_query("SELECT * FROM mp3 WHERE
                                ( filename LIKE REPLACE('%$value%', ' ', '_') OR
                                path LIKE REPLACE('%$value%', ' ', '_') OR
                                filename LIKE '%$value%' OR 
                                path LIKE '%$value%') AND $genrestring", $db);
      } else {
         if ($searchon == "tracknum") {
            $result = mysql_query("SELECT * FROM mp3 WHERE
                                   $searchon = $value",$db);
         } else {
            if ($searchonfilename == "yes") {
               $result = mysql_query("SELECT * FROM mp3 WHERE
                                      (filename LIKE REPLACE('%$value%', ' ', '_') OR
                                      path LIKE REPLACE('%$value%', ' ', '_') OR
                                      $searchon LIKE REPLACE('%$value%', ' ', '_') OR
                                      $searchon LIKE '%$value%' OR
                                      filename LIKE '%$value%' OR
                                      path LIKE '%$value%') AND $genrestring",$db);
            } else {
               $result = mysql_query("SELECT * FROM mp3 WHERE
                             ($searchon LIKE '%$value%' OR
                             $searchon LIKE REPLACE('%$value%', ' ', '_'))
                              AND $genrestring");
            }
         }
      }
      if ($result and $myrow = mysql_fetch_array($result)) {
         $num = mysql_numrows($result);
         print "Number of hits: $num<p>\n";
         if ($num < $max_num) {
            echo "<table border=\"0\" cellspacing=\"7\">\n<tr>
            <th>Title</th>       <th>Artist</th>     <th>Year</th>
            <th>Album</th>       <th>Genre</th>      <th>Server</th></tr>\n";
            do {
               if ($myrow["title"]) {
                  printf("<tr><td><a href=\"details.php3?id=%s\">",
                           $myrow["id"]);
                  printf("%s</a></td>", $myrow["title"]);
                  printf("<td>%s</td><td>%s</td><td>%s</td>
                          <td>%s</td><td>%s</td>
                          </tr>\n",
                          $myrow["artist"],  $myrow["year"],  $myrow["album"],
                          lookup_genre($myrow["genre"]),  $myrow["server"]);
               } else {
                  printf("<tr><td colspan=\"4\">
                          <a href=\"details.php3?id=%s\">",
                          $myrow["id"]);
                  printf("%s</a></td>", $myrow["filename"]);
                  printf("<td>%s</td><td>%s</td>
                          </tr>\n",
                          lookup_genre($myrow["genre"]),  $myrow["server"]);
               }
              
            } while ($myrow = mysql_fetch_array($result));

            echo "</table>\n<p>";
            if ($searchonfilename) {
               $evalue = ereg_replace(" ", "+", $value);
               echo "Repeat your search
               <a href=\"$PHP_SELF?genre=$genre&searchon=$searchon&value=$evalue\">
               without filenames matching</a>\n";
            } else {
               $evalue = ereg_replace(" ", "+", $value);
               echo "Repeat your search <a href=\"$PHP_SELF?genre=$genre&searchon=$searchon&value=$evalue&searchonfilename=yes\">with filenames matching</a>\n";
            }
         } else {
            print "Too many matches. Please narrow your search.\n";
         }
      } else {
         echo "No match :(\n";
         if (!($searchonfilename)) {
            $evalue = ereg_replace(" ", "+", $value);
            echo "Repeat your search <a href=\"$PHP_SELF?genre=$genre&searchon=$searchon&value=$evalue&searchonfilename=yes\">with filenames matching</a>\n";
         }
      }
   } else {
      $result = mysql_query("SELECT * FROM mp3",$db);
      $num = mysql_numrows($result);
      echo "<p>  Welcome to our MP3 database. We currently know about $num MP3s.
      <p> To search for a file, use the
      search form by clicking on the link to your left.
      <p>Please note - this is an early release and things might break;
      also the search algorithms aren't particularly advanced yet.
      Please visit the <a href=\"http://sourceforge.net/projects/mediadbs/\">
      Sourceforge project page</a>
      for questions and comments - in particular the bug report and
      forums.";
   }
}

include("footer.inc");

?>
